//If we've already executed this version of the script, don't do it again.
if ($Server::CarColorSchemesVersion >= 3) return;

$Server::CarColorSchemesVersion = 3;    //Assign current version so that the stuff below doesn't run twice.

package CarColorSchemes
{
    function Vehicle::setNodeColor(%veh, %node, %color)
    {
        %this = %veh.getDatablock();
        if(%node $= "ALL" && %this.storedColorScheme) //We're trying to paint ALL nodes on a car that will use this script
        {
            %target = %veh.colorSchemeTarget;

            if(%target >= %veh.numColorSchemeTargets || %veh.numColorSchemeTargets < 2) return parent::setNodeColor(%veh, %node, %color);
                //Don't try to paint a section that doesn't exist.
                                                 //Don't bother with the script if there's only one section.

            %veh.colorSchemeColor[%target] = %color; //Assign the painted color to the target's saved color.
            // announce(%this.colorSchemeidentifier);
            if(%this.colorSchemeIdentifier !$= "")
            {
                // announce("Sack");
                %veh.spawnbrick.colorSchemeColor[%this.colorSchemeIdentifier, %target] = %color;
            }

            //The base color is treated differently than painting individual sections.
            if(%target == 0) //If we're targeting the vehicle's base color,
            {
                parent::setNodeColor(%veh,%node,%color); //paint everything like usual.

                //With everything painted, we now need to restore the colors set for the secondary areas.
                for(%i = 1; %i < %veh.numColorSchemeTargets; %i++)
                {
                    if(strlen(%veh.colorSchemeNodes[%i]) != 0 && getWord(%veh.colorSchemeColor[%i], 3) == 1) //Each node list on the car...
                    //If the string is unassigned, or color null (by using transparency) this check will fail, causing NOTHING to happen
                    //In other words, the nodes which might otherwise be painted by this section are painted like the base color!
                    {
                        %count = getWordCount(%veh.colorSchemeNodes[%i]) - 1;
                        for(%j = 0; %j <= %count; %j++) //Each node in the node list...
                        {
                            %part = getWord(%veh.colorSchemeNodes[%i], %j);    //Find out which part of the car we're looking at
                            if(%part !$= "ALL" && %part !$= "")
                                %veh.setNodeColor(%part, %veh.colorSchemeColor[%i]);
                        }
                    }
                }
            } //Finished dealing with base color.
            else if(strlen(%veh.colorSchemeNodes[%target]) != 0) //If we are targeting a specific section...
            {
                %count = getWordCount(%veh.colorSchemeNodes[%target]) - 1;
                for(%j = 0; %j <= %count; %j++) //Each node in the node list...
                {
                    %part = getWord(%veh.colorSchemeNodes[%target], %j);    //Find out which part of the car we're looking at
                    if(%part !$= "ALL" && %part !$= "")
                        %veh.setNodeColor(%part, %veh.colorSchemeColor[%target]);
                }
            }


        }
        else return parent::setNodeColor(%veh, %node, %color);
    }

    function fxDTSBrick::colorVehicle(%this)
    {
        if(%this.reColorVehicle $= "1" && %this.vehicleDataBlock.storedColorScheme)
        {   //If the car uses a color scheme, recoloring the brick should change the base color, not the current target.
            %veh = %this.vehicle;
            %temp = %veh.colorSchemeTarget;
            %veh.colorSchemeTarget = 0; //%veh.brickcolorSchemeTarget; //If not specified, this will act like 0 (the base color)
            parent::colorVehicle(%this, %veh);
            %veh.colorSchemeTarget = %temp;
            return;
        }
        else
        {
            return parent::colorVehicle(%this);
        }
    }
};
activatepackage(CarColorSchemes);