datablock TSShapeConstructor(Emperor80DTS)
{
	baseShape  = "./shapes/emperor.dts";
	sequence0  = "./shapes/steering.dsq steering";
};

datablock fxLightData(Emperor80HeadLight)
{
	radius = 50;
	brightness = 4;
	color = "1 0.85 0.55 1";
	flareOn = false;
};

datablock WheeledVehicleData(Emperor80vehicle)
{
	category = "Vehicles";
	uiName = "Emperor '80";

	massCenter = "0 0 0.4";

	engineTorque = 2500;
	engineBrake = 1000;
	brakeTorque = 3500;
	maxWheelSpeed = 40;

	handsOnVehicle = 1;
	shiftBrickCarControls = 1;
	hasScriptedHeadlights = 1;
	mountedLightBotMount = 5;
	usesVehicleEditHelper = 1;
	storedColorScheme = 1;
	colorSchemeIdentifier = "Emperor80";

	numFactoryColorGroups = 3;

	numFactoryColors[0] = 21;
	factoryColor[0, 1] = "ECE4D3 Cotillion White";		//11
	factoryColor[0, 2] = "7D8185 Platinum";				//15
	factoryColor[0, 3] = "111111 Sable black (20)";		//19
	factoryColor[0, 4] = "5B7E9C Steel blue";			//21
	factoryColor[0, 5] = "2E4A64 Superior blue (4)";	//22
	factoryColor[0, 6] = "0F0F2F Twilight blue";		//29
	factoryColor[0, 7] = "2F1F1A Canyon rock (18)";		//36
	factoryColor[0, 8] = "C9E1D1 Princess green"; 		//41
	factoryColor[0, 9] = "063536 Blackwatch green";	 	//49
	factoryColor[0, 10] = "EED69A Colonial yellow";	 	//54
	factoryColor[0, 11] = "F6E5C7 Flax"; 				//59
	factoryColor[0, 12] = "AB8772 Sandstone (18)";		//61
	factoryColor[0, 13] = "24221D Columbian brown";	 	//67
	factoryColor[0, 14] = "220F0F Bordeaux red"; 		//76
	factoryColor[0, 15] = "4F0B0A Saxony red"; 			//78
	factoryColor[0, 16] = "9BA9BF Norfolk gray"; 		//89
	factoryColor[0, 17] = "668DB0 Azure blue (6)";		//90
	factoryColor[0, 18] = "98856E Desert sand (13)";	//91
	factoryColor[0, 19] = "310809 Victoria plum (14)"; 	//92
	factoryColor[0, 20] = "385269 Sheffield gray (16)"; //94
	factoryColor[0, 21] = "B88162 Western saddle (13)"; //96

	numFactoryColors[1] = 15;
	factoryColor[1, 1] = "DDD9CA White";
	factoryColor[1, 2] = "929C9B Light slate gray";
	factoryColor[1, 3] = "576061 Dark gray";
	factoryColor[1, 4] = "1B1B1B Black";
	factoryColor[1, 5] = "17242C Dark blue";
	factoryColor[1, 6] = "283634 Dark green";
	factoryColor[1, 7] = "E9D8A6 Light yellow";
	factoryColor[1, 8] = "8A785A Dark yellow";
	factoryColor[1, 9] = "595544 Very dark yellow";
	factoryColor[1, 10] = "82513B Dark saddle";
	factoryColor[1, 11] = "A69387 Beige";
	factoryColor[1, 12] = "6B5E53 Dark beige";
	factoryColor[1, 13] = "73523D Dark saddle";
	factoryColor[1, 14] = "6E2824 Dark carmine";
	factoryColor[1, 15] = "342A2B Dark claret";

	numFactoryColors[2] = 2;
	factoryColor[2, 1] = "1B1B1B Black";
	factoryColor[2, 2] = "DDD9CA White";

	displayName = "";
	shapeFile = "./shapes/Emperor.dts";
	emap = true;
	minMountDist = 3;

	rollForce = 0;
	yawForce = 0;
	pitchForce = 0;
	rotationalDrag = 1;

	rideable = true;
	lookUpLimit = 0.6;
	lookDownLimit = 0.5;
 
	numMountPoints = 5;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";

	paintable = true;

	maxDamage = 200.00;
	destroyedLevel = 400.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.85;
	integration = 4;
	//tireEmitter = none;

	useEyePoint = false;

	cameraRoll = false;
	cameraMaxDist = 10;
	cameraOffset = 3.5;
	cameraTilt = 0.25;

	cameraLag = 0.0;
	cameraDecay = 0.75;
	collisionTol = 0.1;
	contactTol = 0.1;

	defaultTire = Emperor80Tire;
	defaultSpring = Emperor80Spring;

	numWheels = 4;

	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;

	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.05;
	steeringAutoReturnMaxSpeed = 0.1;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.05;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
   

	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;


	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;

	burnTime = 4000;

	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;



	minRunOverSpeed    = 4;
	runOverDamageScale = 8;
	runOverPushScale   = 1.2;

	protectPassengersBurn   = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;
};