function strIsNum(%str)
{
	%table = "-.1234567890";
	%len = strlen(%str);
	if(%len == 0)
		return false;
	for(%i = 0; %i < %len; %i ++)
	{
		if(strPos(%table, getSubStr(%str, %i, 1)) == -1)
			return false;
	}
	return true;
}

function Emperor80vehicle::generateFactoryColorStrings(%this)
{
	// announce("Generating factory color strings...");
	for(%j = 0; %j < %this.numFactoryColorGroups; %j++)
	{
		%this.factoryColorString[0, %j] = "";
		// announce("Group " @ %j @ ": Factory colors: " @ %this.numFactoryColors[%j]);
		if(%this.numFactoryColors[%j] < 11)
		{
			// announce("Group " @ %j @ " is short");
			for(%i = 1; %i <= %this.numFactoryColors[%j]; %i++)
			{
				%this.factoryColorString[0, %j] = %this.factoryColorString[0, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
			}
		}
		else
		{
			for(%i = 1; %i <= 10; %i++)
			{
				%this.factoryColorString[0, %j] = %this.factoryColorString[0, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
			}
			%this.factoryColorString[1, %j] = "";
			for(%i = 11; %i <= %this.numFactoryColors[%j]; %i++)
			{
				%this.factoryColorString[1, %j] = %this.factoryColorString[1, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
			}
		}
	}
}

Emperor80vehicle.generateFactoryColorStrings();

function Emperor80vehicle::displayFactoryColorString(%this, %veh, %c)
{	
	if(%veh.colorSchemeTarget == 0 && %veh.spawnBrick.reColorVehicle)
	{
		%c.chatMessage("    \c7Colors for current target: \c8N/A - \c0Re-Color Vehicle\c6 is checked on the vehicle's spawn brick. Base colors are unavailable.");
	}
	else
	{
		// announce("Factory colors on current target: " @ %this.numFactoryColors[%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
		%c.chatMessage("    \c7Colors for current target: " @  %this.factoryColorString[0, %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
		if(%this.numFactoryColors[%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]] > 10)
		{
			%c.chatMessage("    " @  %this.factoryColorString[1, %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
		}
	}

	return;
}

function Emperor80vehicle::displayColorTargets(%this, %veh, %c)
{
	if(%veh.spawnBrick.reColorVehicle) %color = "\c8";
	else if(0 == %veh.colorSchemeTarget)%color= "\c3";
	                              else %color = "\c7";

	%c.chatMessage("            \c4T 0 \c8- " @ %color @ %veh.colorSchemeName[0]);

	for(%i = 1; %i < %veh.numColorSchemeTargets; %i++)
	{
		if(%i == 0 || strlen(%veh.colorSchemeNodes[%i]) != 0)
		{
			if(%i == %veh.colorSchemeTarget)
				%color = "\c3";
			else if (getWord(%veh.colorSchemeColor[%i], 3) != 1 || strlen(%veh.colorSchemeNodes[%i]) == 0)
				%color = "\c8";
            else
                %color = "\c7";

			%c.chatMessage("            \c4T " @ %i @ " \c8- " @ %color @ %veh.colorSchemeName[%i]);
		}
	}
}

function Emperor80vehicle::deleteCurrentPaintTarget(%this, %veh, %c, %vehname)
{
	%c.chatMessage();
	%veh.colorSchemeColor[%veh.colorSchemeTarget] = "0 0 0 0";
	%veh.spawnbrick.colorSchemeColor[%this.colorSchemeIdentifier, %veh.colorSchemeTarget] = "0 0 0 0";
	%c.chatMessage(%vehname @ "\c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget] @ "\c6 now matches base color. Paint target changed to \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[0]);
	%veh.colorSchemeTarget = 0;
	%veh.setNodeColor("ALL", %veh.colorSchemeColor[0]);
	Emperor80vehicle.displayFactoryColorString(%veh, %c);
	Emperor80vehicle.displayColorTargets(%veh, %c);
}

function Emperor80vehicle::VehicleEditHelper(%this, %veh, %c, %arg1, %arg2, %arg3)
{
	%vehname = "\c5Emperor '80 VEH\c6: ";
	%this = %this.getid();

	if(getSimTime() - %c.VEHactivationTimer < 250)
	{
		%c.VEHactivationTimer = getSimTime();
		return %c.chatMessage(%vehname @ "Let's not activate complicated scripts too quickly.");
	}
	%c.VEHactivationTimer = getSimTime();

	if(getTrustLevel(%c, %veh) < 2)
		return %c.chatMessage(%vehname @ "You can't change a vehicle without the owner's trust.");

		//Screw that, this restriction is mostly just annoying to me at this point.
	// %veh.speed = vectorLen(%veh.getVelocity());
	// if(%veh.speed > 5)	
	// 	return %c.chatMessage("\c3The vehicle can't be customized while in motion.");

	if(%arg1 $= "B")
	{
        %veh.bodytype = %veh.bodytype + 1;
        if(%veh.bodytype > 2)
        	%veh.bodytype = 0;

		%this.applyParts(%veh, "body");

        return;
	}

	if(%arg1 $= "R")
	{
        %veh.roofopen = !%veh.roofopen;

		%this.applyParts(%veh, "roof");

        return;
	}

	if(getSubStr(%arg1, 0, 2) $= "ra")
	{
		%c.VEHactivationTimer = %c.VEHactivationTimer + 750;
		%this.setDefaultBrickAttributes(%veh);
		return;
	}



	// if(1)//!%veh.spawnbrick.reColorVehicle)
	// {
		if(%arg1 $= "c") //View factory colors
		{
			///

			// if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
			// {
			// 	%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
			// }
			// else
			// {
				%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
			// }

			///

			%c.chatMessage("\c0-----\c7Emperor '80 colors (via 1980 Cadillac)\c0-----");
			%c.chatMessage("    <color:888888>Usage: \c4/veh _ \c6with by one of the numbers below. e.g. '\c4/veh 1\c6'");
			// %c.chatMessage("        \c6If you type two numbers, you can use the factory colors for a different target.");

			if(%veh.colorSchemeTarget == 0 && %veh.spawnBrick.reColorVehicle)
			{
				%c.chatMessage("\c8N/A - \c0Re-Color Vehicle\c6 is checked on the vehicle's spawn brick. Base colors are unavailable.");
			}
			else 
			{
				if(%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget] == 0)
				{
					%c.chatMessage("        \c6The numbers next to some colors are the suggested two-tone/roof colors.");
				}

				for(%i = 1; %i <= %this.numFactoryColors[%factoryColorGroup]; %i++)
				{
					%c.chatMessage("        \c6" @ %i @ ":   <color:" @ getWord(%this.factoryColor[%factoryColorGroup, %i], 0) @ ">[" @ getWords(%this.factoryColor[%factoryColorGroup, %i], 1) @ "]");
				}
			}

        	return;
		}
		
		if(strIsNum(%arg1)) //Apply factory colors
		{
			///

			// if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
			// {
			// 	%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
			// }
			// else
			// {
				%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
			// }

			///

			if(%arg1 > 0 && %arg1 <= %this.numFactoryColors[%factoryColorGroup])
			{
				return %veh.setNodeColor("ALL", getColorF(getWord(%this.factoryColor[%factoryColorGroup, %arg1], 0)));
			}

			else if(%arg1 == 0 && %veh.colorSchemeTarget != 0)
			{
				return Emperor80Vehicle.deleteCurrentPaintTarget(%veh, %c, %vehname);
			}
			
			else
			{
				%c.chatMessage(%vehname @ "That is not a valid factory color for \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);
				Emperor80vehicle.displayFactoryColorString(%veh, %c);
				return;
			}
		}

		if(%arg1 $= "t")
		{
			if(%arg2 $="")
			{
				%proposedtarget = %veh.colorSchemeTarget + 1;
				if(%proposedtarget >= %veh.numColorSchemeTargets)
					%proposedtarget = 0;
			}
			else if(%arg2 < 0 || %arg2 >= %veh.numColorSchemeTargets)
			{
				return %c.chatmessage(%vehname @ "That is not a valid color scheme number.");
			}
			else
			{
				%proposedtarget = %arg2;
			}

			%veh.colorSchemeTarget = %proposedTarget;
			%c.chatMessage(%vehname @ "Paint target changed to \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);

			if(!%c.VEH3argHintGiven)
			{
				%c.chatMessage("\c2One-time hint\c6: If you type a third argument, like \c4/veh t 2 3\c6 or \c4/veh t 2 c\c6, you can apply or view factory colors immediately after changing targets.");
				%c.VEH3argHintGiven = true;
			}

			Emperor80vehicle.displayFactoryColorString(%veh, %c);
			
			Emperor80vehicle.displayColorTargets(%veh, %c);

			if(%arg3 $= "c")
			{
				%c.VEHactivationTimer = %c.VEHactivationTimer - 1000;
				Emperor80vehicle.VehicleEditHelper(%veh, %c, "c");
			}

			if(strIsNum(%arg3)) //Apply factory colors
			{
				///

				// if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
				// {
				// 	%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
				// }
				// else
				// {
					%factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
				// }

				///

				if(%arg3 > 0 && %arg3 <= %this.numFactoryColors[%factoryColorGroup])
				{
					return %veh.setNodeColor("ALL", getColorF(getWord(%this.factoryColor[%factoryColorGroup, %arg3], 0)));
				}

				else if(%arg3 == 0 && %veh.colorSchemeTarget != 0)
				{
					Emperor80Vehicle.deleteCurrentPaintTarget(%veh, %c, %vehname);
				}
				
				else
				{
					%c.chatMessage(%vehname @ "That is not a valid factory color for \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);
					Emperor80vehicle.displayFactoryColorString(%veh, %c);
				}
			}

			return;
		}
	// }



	%c.chatMessage("\c8-----\c0Emperor '80 \c8- \c0Vehicle Edit Helper\c8-----");
	%c.chatMessage("        <color:8888AA>Shift brick <color:FFAA00>LEFT / RIGHT:<color:FFDD88> Turn signals; <color:8888AA>Shift brick <color:FFAA00>DOWN: <color:FFDD88>Hazard lights");
	%c.chatMessage("    <color:888888>Usage: \c4/veh __ \c6with one of the words below.");
	%c.chatMessage("        \c1B \c8- \c6Cycle \c1body type\c6 between sedan, coupe, and convertible.");
	if(%veh.bodytype == 2)
		%c.chatMessage("        \c2R \c8- \c6Toggle \c2roof cover\c6 on the covertible.");

	// if(0)//%veh.spawnbrick.reColorVehicle)
	// {
	// 	%c.chatMessage("    \c3This car's spawn brick has Re-Color Vehicle checked. Colors are locked!");
	// }
	// else
	// {
		// %c.chatMessage("        \c0C \c3# \c8- \c6View factory colors; \c0# \c3# \c8- \c6Apply factory color. Include \c3# \c6to change paint target.");
		%c.chatMessage("        \c0# \c8- \c6Apply factory color; \c0C \c8- \c6View factory colors and names for current target.");
		%c.chatMessage("        \c0random \c8- \c6Randomize factory colors on all parts!");
		if(%veh.colorSchemeTarget != 0 && strlen(%veh.colorSchemeNodes[%veh.colorSchemeTarget]) != 0 && getWord(%veh.colorSchemeColor[%veh.colorSchemeTarget], 3) == 1)
		{
		%c.chatMessage("        \c00 \c8- \c6Remove current paint target's color (match base color)");
		}
		Emperor80vehicle.displayFactoryColorString(%veh, %c);
		%c.chatMessage("        \c4T \c8- \c6Cycle paint target.");
					
		Emperor80vehicle.displayColorTargets(%veh, %c);
	// }
}