function Emperor80vehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		//If a signal is on, that side will be left alone

		if(%veh.signal == -1)		//Don't touch the taillight if the turn signal is on
		{
			%veh.hidenode(lights_brakeR0);
			%veh.hidenode(lights_brakeR1);
			%veh.unhidenode(lights_brakeR2);
		}
		else if(%veh.signal == 1)
		{
			%veh.hidenode(lights_brakeL0);
			%veh.hidenode(lights_brakeL1);
			%veh.unhidenode(lights_brakeL2);
		}
		else if(%veh.signal == 0)
		{
			%veh.hidenode(lights_brakeR0);
			%veh.hidenode(lights_brakeR1);
			%veh.unhidenode(lights_brakeR2);
			%veh.hidenode(lights_brakeL0);
			%veh.hidenode(lights_brakeL1);
			%veh.unhidenode(lights_brakeL2);
		}
	}
	else
	{	//brake off
		%veh.braking = 0;


		if(%veh.signal == -1)
		{
			%veh.hidenode(lights_brakeR2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeR0);

			else
				%veh.unhidenode(lights_brakeR1);
		}
		else if(%veh.signal == 1)
		{
			%veh.hidenode(lights_brakeL2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeL0);

			else
				%veh.unhidenode(lights_brakeL1);
		}
		else if(%veh.signal == 0)
		{
			%veh.hidenode(lights_brakeR2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeR0);

			else
				%veh.unhidenode(lights_brakeR1);


			%veh.hidenode(lights_brakeL2);

			if(%veh.headlightState == 0)
				%veh.unhidenode(lights_brakeL0);

			else
				%veh.unhidenode(lights_brakeL1);
		}
	}
}

function Emperor80vehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 3)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);

        	// if(%veh.lightsup)
        	// {
        	// 	%veh.playThread(0, lightsdown);
        	// 	%veh.lightsup = false;
        	// }

			%veh.unhidenode(headlightsA0);
			%veh.unhidenode(headlightsB0);
			%veh.unhidenode(lights_idlesignalL0);
			%veh.unhidenode(lights_idlesignalR0);

			%veh.hidenode(headlightsA1);
			%veh.hidenode(headlightsB1);
			%veh.hidenode(lights_idlesignalL1);
			%veh.hidenode(lights_idlesignalR1);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR1);
					%veh.unhidenode(lights_brakeR0);
				}
				if(%veh.signal == 1)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL1);
					%veh.unhidenode(lights_brakeL0);
				}
				if(%veh.signal == 0)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL1);
					%veh.unhidenode(lights_brakeL0);
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR1);
					%veh.unhidenode(lights_brakeR0);
				}
			}
		
		case 1:		//Parking lights
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);

        	// if(%veh.lightsup)
        	// {
        	// 	%veh.playThread(0, lightsdown);
        	// 	%veh.lightsup = false;
        	// }

			%veh.unhidenode(headlightsA0);
			%veh.unhidenode(headlightsB0);
			%veh.unhidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_idlesignalR1);

			%veh.hidenode(headlightsA1);
			%veh.hidenode(headlightsB1);
			%veh.hidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalR0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
			}
		
		case 2:		//Daytime-running lights
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);

        	// if(!%veh.lightsup)
        	// {
        	// 	%veh.playThread(0, lightsup);
        	// 	%veh.lightsup = true;
        	// }

			%veh.unhidenode(headlightsA1);
			%veh.unhidenode(headlightsB0);
			%veh.unhidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_idlesignalR1);

			%veh.hidenode(headlightsA0);
			%veh.hidenode(headlightsB1);
			%veh.hidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalR0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
			}
		
		case 3:		//Full lights including light source
			%veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(Emperor80HeadLight);

        	// if(!%veh.lightsup)
        	// {
        	// 	%veh.playThread(0, lightsup);
        	// 	%veh.lightsup = true;
        	// }

			%veh.unhidenode(headlightsA1);
			%veh.unhidenode(headlightsB1);
			%veh.unhidenode(lights_idlesignalL1);
			%veh.unhidenode(lights_idlesignalR1);

			%veh.hidenode(headlightsA0);
			%veh.hidenode(headlightsB0);
			%veh.hidenode(lights_idlesignalL0);
			%veh.hidenode(lights_idlesignalR0);
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.hidenode(lights_brakeL2);
					%veh.hidenode(lights_brakeL0);
					%veh.unhidenode(lights_brakeL1);
					%veh.hidenode(lights_brakeR2);
					%veh.hidenode(lights_brakeR0);
					%veh.unhidenode(lights_brakeR1);
				}
			}
	}
} //End of headlights


/////////////////////////////////////////////////////////////////////////////////


function Emperor80vehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	if(%direction == 0 || %direction != %veh.signal)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used

		if(%veh.braking)				//If the car is braking, return taillights to bright red
		{
			%veh.hidenode(lights_brakeR0);
			%veh.hidenode(lights_brakeL0);
			%veh.hidenode(lights_brakeR1);
			%veh.hidenode(lights_brakeL1);
			%veh.unhidenode(lights_brakeR2);
			%veh.unhidenode(lights_brakeL2);
		}
		else if(%veh.headlightState == 0)	//If no brakes and lights are off, return taillights to completely off
		{
			%veh.unhidenode(lights_brakeR0);
			%veh.unhidenode(lights_brakeL0);
			%veh.hidenode(lights_brakeR1);
			%veh.hidenode(lights_brakeL1);
			%veh.hidenode(lights_brakeR2);
			%veh.hidenode(lights_brakeL2);
		}
		else							//If no brakes and lights are on, return taillights to dim red
		{
			%veh.hidenode(lights_brakeR0);
			%veh.hidenode(lights_brakeL0);
			%veh.unhidenode(lights_brakeR1);
			%veh.unhidenode(lights_brakeL1);
			%veh.hidenode(lights_brakeR2);
			%veh.hidenode(lights_brakeL2);
		}

		%veh.unhideNode(lights_signalR0);
		%veh.unhideNode(lights_signalL0);
		%veh.hideNode(lights_signalR1);
		%veh.hideNode(lights_signalL1);

		if(%veh.headlightState == 0)
		{
			%veh.unhideNode(lights_idlesignalR0);
			%veh.unhideNode(lights_idlesignalL0);
			%veh.hideNode(lights_idlesignalR1);
			%veh.hideNode(lights_idlesignalL1);
		}
		else
		{
			%veh.hideNode(lights_idlesignalR0);
			%veh.hideNode(lights_idlesignalL0);
			%veh.unhideNode(lights_idlesignalR1);
			%veh.unhideNode(lights_idlesignalL1);
		}
	}	//END OF TURN OFF SIGNAL

	%veh.signal = %direction;	//Other functions must know which direction is being used
	if(%direction == 0)	return;



	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			%veh.hideNode(lights_signalR0);
			%veh.unhideNode(lights_signalR1);
			%veh.hideNode(lights_idlesignalR0);
			%veh.unhideNode(lights_idlesignalR1);

			%veh.hideNode(lights_brakeR0);
			%veh.hideNode(lights_brakeR1);
			%veh.unhideNode(lights_brakeR2);
		}
		else if(%direction == -1)	//Left side turn on
		{
			%veh.hideNode(lights_signalL0);
			%veh.unhideNode(lights_signalL1);
			%veh.hideNode(lights_idlesignalL0);
			%veh.unhideNode(lights_idlesignalL1);

			%veh.hideNode(lights_brakeL0);
			%veh.hideNode(lights_brakeL1);
			%veh.unhideNode(lights_brakeL2);
		}
		else //Hazard lights on
		{
			%veh.hideNode(lights_signalR0);
			%veh.unhideNode(lights_signalR1);
			%veh.hideNode(lights_idlesignalR0);
			%veh.unhideNode(lights_idlesignalR1);
			%veh.hideNode(lights_signalL0);
			%veh.unhideNode(lights_signalL1);
			%veh.hideNode(lights_idlesignalL0);
			%veh.unhideNode(lights_idlesignalL1);

			%veh.hideNode(lights_brakeR0);
			%veh.hideNode(lights_brakeR1);
			%veh.unhideNode(lights_brakeR2);

			%veh.hideNode(lights_brakeL0);
			%veh.hideNode(lights_brakeL1);
			%veh.unhideNode(lights_brakeL2);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{
			%veh.unhideNode(lights_idlesignalR0);
			%veh.hideNode(lights_idlesignalR1);
			%veh.unhideNode(lights_signalR0);
			%veh.hideNode(lights_signalR1);

			%veh.hideNode(lights_brakeR2);
			if(%veh.headlightState > 0) %veh.unhideNode(lights_brakeR1);
			else                        %veh.unhideNode(lights_brakeR0);
		}
		else if(%direction == -1)	//Left side turn off
		{
			%veh.unhideNode(lights_idlesignalL0);
			%veh.hideNode(lights_idlesignalL1);
			%veh.unhideNode(lights_signalL0);
			%veh.hideNode(lights_signalL1);

			%veh.hideNode(lights_brakeL2);
			if(%veh.headlightState > 0) %veh.unhideNode(lights_brakeL1);
			else						%veh.unhideNode(lights_brakeL0);
		}
		else //Hazard lights off
		{
			%veh.unhideNode(lights_idlesignalR0);
			%veh.hideNode(lights_idlesignalR1);
			%veh.unhideNode(lights_signalR0);
			%veh.hideNode(lights_signalR1);
			%veh.unhideNode(lights_idlesignalL0);
			%veh.hideNode(lights_idlesignalL1);
			%veh.unhideNode(lights_signalL0);
			%veh.hideNode(lights_signalL1);

			%veh.hideNode(lights_brakeR2);
			%veh.hideNode(lights_brakeL2);
			if(%veh.headlightState > 0)
			{
				%veh.unhideNode(lights_brakeR1);
				%veh.unhideNode(lights_brakeL1);
			}
			else
			{
				%veh.unhideNode(lights_brakeR0);
				%veh.unhideNode(lights_brakeL0);
			}
		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(470, turnSignal, %veh, %direction);
}