package Emperor80Package
{
    function emperor80hearsevehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        %veh.spawnMountedLightBot(%this.mountedlightbotmount);

        %veh.hidenode(headlightsA1);
        %veh.hidenode(headlightsB1);
        %veh.hidenode(lights_idlesignalR1);
        %veh.hidenode(lights_idlesignalL1);
        %veh.hidenode(lights_signalR1);
        %veh.hidenode(lights_signalL1);
        %veh.hidenode(lights_brakeR1);
        %veh.hidenode(lights_brakeR2);
        %veh.hidenode(lights_brakeL1);
        %veh.hidenode(lights_brakeL2);
        //%veh.hidenode(lights_reverse1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
    }

    function emperor80hearsevehicle::setDefaultBrickAttributes(%this, %veh)
    {
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        %brick.numColorSchemeTargets[%ID] = 5;

        if(getRandom() < 0.5)
            %a = 3;
        else
        {
            if(getRandom() < 0.75)
            {
                if(getRandom() < 0.33)
                %a = 1;
                else if(getRandom() < 0.66)
                %a = 2;
                else
                %a = 4;
            }
            else
                %a = getRandom(%this.numFactoryColors[0] - 1) + 1;
        }

        if(getRandom() < 0.66)
            %roof = getColorF(getWord(%this.factoryColor[0, 3], 0));
        else
            %roof = "0 0 0 0";

        %brick.colorSchemeName[%ID, 0] = "Base";
        %brick.colorSchemeFactoryColorGroup[%ID, 0] = 0;
        %brick.colorSchemeColor[%ID, 0] = getColorF(getWord(%this.factoryColor[0, %a], 0));

        %brick.colorSchemeName[%ID, 1] = "Two-tone";
        %brick.colorSchemeNodes[%ID, 1] = "twotone";
        %brick.colorSchemeFactoryColorGroup[%ID, 1] = 0;
        %brick.colorSchemeColor[%ID, 1] = "0 0 0 0";

        %brick.colorSchemeName[%ID, 2] = "Interior";
        %brick.colorSchemeNodes[%ID, 2] = "interior steeringwheel";
        %brick.colorSchemeFactoryColorGroup[%ID, 2] = 1;
        %brick.colorSchemeColor[%ID, 2] = getColorF(getWord(%this.factoryColor[1, 4], 0));

        %brick.colorSchemeName[%ID, 3] = "Roof";
        %brick.colorSchemeNodes[%ID, 3] = "roof";
        %brick.colorSchemeFactoryColorGroup[%ID, 3] = 0;
        %brick.colorSchemeColor[%ID, 3] = %roof;

        %brick.colorSchemeName[%ID, 4] = "Curtains";
        %brick.colorSchemeNodes[%ID, 4] = "curtains";
        %brick.colorSchemeFactoryColorGroup[%ID, 4] = 2;
        %brick.colorSchemeColor[%ID, 4] = getColorF(getWord(%this.factoryColor[2, 2], 0));

        // announce(%brick.colorSchemeColor[%ID, 0]);

        %brick.carAttributesSet[%ID] = true;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);

        return;
    }

    function emperor80hearsevehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        if(!%brick.carAttributesSet[%ID])
        {
            %this.setDefaultBrickAttributes(%veh);
        }

        %veh.numColorSchemeTargets = %brick.numColorSchemeTargets[%ID];

        for(%i = 0; %i < %brick.numColorSchemeTargets[%ID]; %i++)
        {
            //announce(%brick.colorSchemeName[%this, %i]);
            %veh.colorSchemeName[%i] = %brick.colorSchemeName[%ID, %i];
            if(%i > 0) 
            {
                %veh.colorSchemeNodes[%i] = %brick.colorSchemeNodes[%ID, %i];
            }
            %veh.colorSchemeFactoryColorGroup[%i] = %brick.colorSchemeFactoryColorGroup[%ID, %i];
            %veh.colorSchemeColor[%i] = %brick.colorSchemeColor[%ID, %i];
        }

        // %this.applyParts(%veh); //Apply all hidden/unhidden nodes
        
        %veh.colorSchemeTargetRestore = %veh.colorSchemeTarget;
        %veh.colorSchemeTarget = 0;
        %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Reapply current color to cause changes
        %veh.colorSchemeTarget = %veh.colorSchemeTargetRestore;
    }
};
activatepackage(Emperor80Package);

function emperor80hearsevehicle::onDriverEnter(%this, %veh)
{   
    //onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
    // The hasDriver variable makes it so these things are done only one time each.
    if(!%veh.hasDriver)
    {
        %veh.hasDriver = 1;
        
        %this.headlights(%veh, "restore");
        
        // %this.SpeedCheck(%veh);
    }
}

function emperor80hearsevehicle::onDriverLeave(%this, %veh)
{       
    if(%veh.hasDriver)
    {
        %veh.hasDriver = 0;

        if(%veh.braking)
        {
            %veh.braking = 0;
            %veh.hidenode(lights_brakeR2);
            %veh.hidenode(lights_brakeL2); 

            if(%veh.headlightState > 0)
            {
                %veh.unhidenode(lights_brakeR1);
                %veh.unhidenode(lights_brakeL1); 
            }
            else
            {
                %veh.unhidenode(lights_brakeR0);
                %veh.unhidenode(lights_brakeL0); 
            }
        }
        
        // %veh.reversing = 0;
        // %veh.unhidenode(lights_reverse0);
        // %veh.hidenode(lights_reverse1);

        // cancel(%veh.SpeedCheckSchedule);
        if(%veh.signal != -11) %this.turnSignal(%veh, 0);
        %veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);
    }
}

function emperor80hearsevehicle::onRemove(%this, %veh)
{
    %veh.removeMountedLightBot(%this.mountedlightbotmount);
}

// function emperor80hearsevehicle::SpeedCheck(%this, %veh)
// {
//     if(isEventPending(%veh.SpeedCheckSchedule)) return;
//     if(!isObject(%veh)) return;
    
//     %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
//     if(!%veh.reversing && %veh.speed <= -3)
//     {
//         %veh.hidenode(lights_reverse0);
//         %veh.unhidenode(lights_reverse1);
//         %veh.reversing = 1;
//     }
//     else if(%veh.reversing && %veh.speed > -0.1)
//     {
//         %veh.unhidenode(lights_reverse0);
//         %veh.hidenode(lights_reverse1);
//         %veh.reversing = 0;
//     }
    
//     %veh.SpeedCheckSchedule = %data.schedule(111, "SpeedCheck", %veh);
// }
