package emperor80lowriderPackage
{
    function emperor80lowriderVehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        %veh.spawnMountedLightBot(%this.mountedlightbotmount);

        %veh.playThread(0, hood1);

        %veh.hidenode(headlightsA1);
        %veh.hidenode(headlightsB1);
        %veh.hidenode(lights_idlesignalR1);
        %veh.hidenode(lights_idlesignalL1);
        %veh.hidenode(lights_signalR1);
        %veh.hidenode(lights_signalL1);
        %veh.hidenode(lights_brakeR1);
        %veh.hidenode(lights_brakeR2);
        %veh.hidenode(lights_brakeL1);
        %veh.hidenode(lights_brakeL2);
        %veh.hidenode(lights_reverse1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
    }

    function emperor80lowridervehicle::setDefaultBrickAttributes(%this, %veh)
    {
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        %brick.numColorSchemeTargets[%ID] = 7;

        %a = getRandom(%this.numFactoryColors[0] - 1) + 1;
        // announce(%a);
        %d = getRandom(%this.numFactoryColors[1] - 1) + 1;


        if(%brick.bodytype[%ID] == 2) //convertible
        {
            %b = "0.1 0.1 0.1 1"; //black roof
            %c = "0 0 0 0"; 
        }
        else
        {
            if(getRandom() < 0.75) //Chance to apply two-tone color scheme
            { 
                switch(%a)
                {
                    case 3:
                        %b = getColorF(getWord(%this.factoryColor[0, 20], 0));
                    case 5:
                        %b = getColorF(getWord(%this.factoryColor[0, 4], 0));
                    case 7:
                        %b = getColorF(getWord(%this.factoryColor[0, 18], 0));
                    case 12:
                        %b = getColorF(getWord(%this.factoryColor[0, 18], 0));
                    case 17:
                        %b = getColorF(getWord(%this.factoryColor[0, 6], 0));
                    case 18:
                        %b = getColorF(getWord(%this.factoryColor[0, 13], 0));
                    case 19:
                        %b = getColorF(getWord(%this.factoryColor[0, 14], 0));
                    case 20:
                        %b = getColorF(getWord(%this.factoryColor[0, 16], 0));
                    case 21:
                        %b = getColorF(getWord(%this.factoryColor[0, 13], 0));
                }
            }

            if(%b $= "")
                %b = "0 0 0 0";

            if(getRandom() < 0.5)
                %c = %b;
            else
                %c = "0 0 0 0"; 
        }

        %brick.colorSchemeName[%ID, 0] = "Base";
        %brick.colorSchemeFactoryColorGroup[%ID, 0] = 0;
        %brick.colorSchemeColor[%ID, 0] = getColorF(getWord(%this.factoryColor[0, %a], 0));


        %brick.colorSchemeName[%ID, 1] = "Two-tone";
        %brick.colorSchemeNodes[%ID, 1] = "twotone sedantwotone twodoortwotone";
        %brick.colorSchemeFactoryColorGroup[%ID, 1] = 0;
        %brick.colorSchemeColor[%ID, 1] = %c; //getColorF(getWord(%this.factoryColor[0, %c], 0));


        %brick.colorSchemeName[%ID, 2] = "Interior";
        %brick.colorSchemeNodes[%ID, 2] = "interior steeringwheel sedaninterior coupeinterior twodoorinterior convertibleinterior";
        %brick.colorSchemeFactoryColorGroup[%ID, 2] = 1;
        %brick.colorSchemeColor[%ID, 2] = getColorF(getWord(%this.factoryColor[1, %d], 0));

        %brick.colorSchemeName[%ID, 3] = "Roof";
        %brick.colorSchemeNodes[%ID, 3] = "sedanroof couperoof";
        %brick.colorSchemeFactoryColorGroup[%ID, 3] = 0;
        %brick.colorSchemeColor[%ID, 3] = %b; //getColorF(getWord(%this.factoryColor[0, %b], 0));

        %brick.colorSchemeName[%ID, 4] = "Convertible top";
        %brick.colorSchemeNodes[%ID, 4] = "softtop0 softtop1";
        %brick.colorSchemeFactoryColorGroup[%ID, 4] = 2;
        %softtop = (getRandom() < 0.2) + 1;
        %brick.colorSchemeColor[%ID, 4] = getColorF(getWord(%this.factoryColor[2, %softtop], 0));

        %brick.colorSchemeName[%ID, 5] = "Interior trim";
        %brick.colorSchemeNodes[%ID, 5] = "dashwood steeringwheelwood twodoorwood sedanwood";
        %brick.colorSchemeFactoryColorGroup[%ID, 5] = 3;
        %brick.colorSchemeColor[%ID, 5] = getColorF(getWord(%this.factoryColor[3, 1], 0));

        %brick.colorSchemeName[%ID, 6] = "Metal trim";
        %brick.colorSchemeNodes[%ID, 6] = "bodymetal dashmetal steeringwheelmetal twodoormetal coupemetal convertiblemetal sedanmetal";
        %brick.colorSchemeFactoryColorGroup[%ID, 6] = 4;
        %brick.colorSchemeColor[%ID, 6] = getColorF(getWord(%this.factoryColor[4, 1], 0));

        // announce(%brick.colorSchemeColor[%ID, 0]);

        %brick.carAttributesSet[%ID] = true;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);

        return;
    }

    function emperor80lowridervehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        // announce("load attributes " @ %this);
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        if(!%brick.carAttributesSet[%ID])
        {
            %brick.roofopen[%ID] = 1; //convertibles always start open
            %brick.bodytype[%ID] = getRandom() < 0.5; //50% chance to be a coupe
            if(getRandom() < 0.2)
            {
                %brick.bodytype[%ID] = 2; //20% chance to be a convertible
            }

            //return %this.schedule(500, setDefaultBrickAttributes, %veh);
            %this.setDefaultBrickAttributes(%veh);
        }

        %veh.bodytype = %brick.bodytype[%ID];
        // %veh.rooftype = %brick.rooftype[%ID];
        %veh.roofopen = %brick.roofopen[%ID];

        %veh.numColorSchemeTargets = %brick.numColorSchemeTargets[%ID];

        for(%i = 0; %i < %brick.numColorSchemeTargets[%ID]; %i++)
        {
            //announce(%brick.colorSchemeName[%this, %i]);
            %veh.colorSchemeName[%i] = %brick.colorSchemeName[%ID, %i];
            if(%i > 0) 
            {
                %veh.colorSchemeNodes[%i] = %brick.colorSchemeNodes[%ID, %i];
            }
            %veh.colorSchemeFactoryColorGroup[%i] = %brick.colorSchemeFactoryColorGroup[%ID, %i];
            %veh.colorSchemeColor[%i] = %brick.colorSchemeColor[%ID, %i];
        }

        %this.applyParts(%veh); //Apply all hidden/unhidden nodes
        
        %veh.colorSchemeTargetRestore = %veh.colorSchemeTarget;
        %veh.colorSchemeTarget = 0;
        %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Reapply current color to cause changes
        %veh.colorSchemeTarget = %veh.colorSchemeTargetRestore;
    }
};
activatepackage(emperor80lowriderPackage);

package onDriverEnterPackage
{
    function armor::onMount(%this, %obj, %vehicle, %node)
    {
        Parent::onMount(%this, %obj, %vehicle, %node);
        
        if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
            %vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
    }

};
activatePackage(onDriverEnterPackage);

function emperor80lowriderVehicle::onDriverEnter(%this, %veh)
{   
    //onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
    // The hasDriver variable makes it so these things are done only one time each.
    if(!%veh.hasDriver)
    {
        %veh.hasDriver = 1;
        
        %this.headlights(%veh, "restore");
        
        %this.SpeedCheck(%veh);
    }
}

function emperor80lowriderVehicle::onDriverLeave(%this, %veh)
{       
    if(%veh.hasDriver)
    {
        %veh.hasDriver = 0;

        if(%veh.braking)
        {
            %veh.braking = 0;
            %veh.hidenode(lights_brakeR2);
            %veh.hidenode(lights_brakeL2); 

            if(%veh.headlightState > 0)
            {
                %veh.unhidenode(lights_brakeR1);
                %veh.unhidenode(lights_brakeL1); 
            }
            else
            {
                %veh.unhidenode(lights_brakeR0);
                %veh.unhidenode(lights_brakeL0); 
            }
        }
        
        %veh.reversing = 0;
        %veh.unhidenode(lights_reverse0);
        %veh.hidenode(lights_reverse1);

        cancel(%veh.SpeedCheckSchedule);
        if(%veh.signal != -11) %this.turnSignal(%veh, 0);
        %veh.mountedLightBot[%this.mountedlightbotmount].setMountedLight(none);
    }
}

function emperor80lowriderVehicle::onRemove(%this, %veh)
{
    %veh.removeMountedLightBot(%this.mountedlightbotmount);
}

function emperor80lowriderVehicle::SpeedCheck(%this, %veh)
{
    if(isEventPending(%veh.SpeedCheckSchedule)) return;
    if(!isObject(%veh)) return;
    
    %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
    if(!%veh.reversing && %veh.speed <= -3)
    {
        %veh.hidenode(lights_reverse0);
        %veh.unhidenode(lights_reverse1);
        %veh.reversing = 1;
    }
    else if(%veh.reversing && %veh.speed > -0.1)
    {
        %veh.unhidenode(lights_reverse0);
        %veh.hidenode(lights_reverse1);
        %veh.reversing = 0;
    }
        // %veh.spawnbrick.carAttributesSet[%this.colorSchemeIdentifier] = false;
        // %this.loadSpawnBrickAttributes(%veh);
    
    %veh.SpeedCheckSchedule = %this.schedule(250, "SpeedCheck", %veh);
}
